// 모터 변수
//EN1 , IN1a , IN1b : 왼쪽모터   Motor1
//EN2 , IN2a , IN2b : 오른쪽모터 Motor2
int EN1 = 2; int EN2 = 3; int IN1a = 4; int IN1b = 5; int IN2a = 6; int IN2b = 7;

// HC-SR04
// trig 53 , echo 50 : 왼쪽 초음파센서
// trig 8  , echo 10 : 오른쪽 초음파센서
int trig[2] = {53,8};   int echo[2] = {50,10};
int distance[2]; int Tdis[2];

// 적외선센서 GP2Y0A41SK0F
int IR_Sensor = A0; int IRDistance;
float Voltage;

void Motor1(int pwm){  
  if(pwm>=0) {
    digitalWrite(IN1a, HIGH);    
    digitalWrite(IN1b, LOW);    
  }
  else {
    digitalWrite(IN1a,LOW);
    digitalWrite(IN1b,HIGH);
  }
  analogWrite(EN1, abs(pwm));
}

void Motor2(int pwm){  
  if(pwm>=0) {
    digitalWrite(IN2a, HIGH);    
    digitalWrite(IN2b, LOW);    
  }
  else {
    digitalWrite(IN2a,LOW);
    digitalWrite(IN2b,HIGH);
  }
  analogWrite(EN2, abs(pwm));
}

float us_op(int num)
{
  float Dis=0;
  digitalWrite(trig[num], HIGH);                                
  delayMicroseconds(10);                                       
  digitalWrite(trig[num], LOW);                                  
  distance[num] = pulseIn(echo[num], HIGH, 5000L) * 17/1000; 
  
  Dis = distance[num];
  if(Dis<=0) Dis=0;
  if(Dis>30) Dis=0;
  distance[num]=0;  
  return Dis;
}

void setup() {
  Serial.begin(9600);
  Serial1.begin(9600);
  
  int i; 
  for(i=0; i<2; i++){
    pinMode(trig[i], OUTPUT);  pinMode(echo[i], INPUT);
  }  
  for(i = 2; i<=7;i++)  pinMode(i,OUTPUT);
}

void loop() 
{
  Voltage = analogRead(IR_Sensor)*0.0048828125;  // value from IR_Sensor * (5/1024)
  IRDistance = 13*pow(Voltage, -1); // worked out from datasheet graph
  if(IRDistance > 15) IRDistance = 0;

    if(Serial1.available())
    {
      char bt = Serial1.read();
      Serial.println(bt);
      if(bt == '5') {
        Motor1(0);
        Motor2(0);
      }
      if(bt == '1') {
        Motor1(100-int(1500/us_op(1))-int(1500/IRDistance));    
        Motor2(100-int(1500/us_op(0))+int(1500/IRDistance));
      }
      if(bt == '2'){
        Motor1(-100); 
        Motor2(-100);
      }
      if(bt == '3'){
        Motor1(-100); 
        Motor2(100);
      }
      if(bt == '4'){
        Motor1(100); 
        Motor2(-100);
      }
    }
}
